Index: i386/isa/intr_machdep.c
===========================================================================
--- sys/i386/isa/intr_machdep.c	2003/10/30 14:48:07	#21
+++ i386/isa/intr_machdep.c	2003/10/30 14:48:07
@@ -39,127 +39,18 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD: src/sys/i386/isa/intr_machdep.c,v 1.76 2003/06/02 16:32:54 obrien Exp $");
 
-#include "opt_auto_eoi.h"
-#include "opt_isa.h"
 #include "opt_mca.h"
 
-#include <sys/param.h>
-#include <sys/bus.h> 
-#include <sys/errno.h>
-#include <sys/interrupt.h>
-#include <sys/kernel.h>
-#include <sys/kthread.h>
-#include <sys/lock.h>
-#include <sys/malloc.h>
-#include <sys/module.h>
-#include <sys/mutex.h>
-#include <sys/proc.h>
+#include <sys/types.h>
 #include <sys/syslog.h>
 #include <sys/systm.h>
-#include <sys/unistd.h>
 
 #include <machine/md_var.h>
-#include <machine/segments.h>
-
-#if defined(APIC_IO)
-#include <machine/smptests.h>			/** FAST_HI */
-#include <machine/smp.h>
-#include <machine/resource.h>
-#endif /* APIC_IO */
-#ifdef PC98
-#include <pc98/pc98/pc98.h>
-#include <pc98/pc98/pc98_machdep.h>
-#include <pc98/pc98/epsonio.h>
-#else
-#include <i386/isa/isa.h>
-#endif
-#include <i386/isa/icu.h>
-
-#ifdef DEV_ISA
-#include <isa/isavar.h>
-#endif
-#include <i386/isa/intr_machdep.h>
-#include <sys/interrupt.h>
-#ifdef APIC_IO
-#include <machine/clock.h>
-#endif
 
 #ifdef DEV_MCA
 #include <i386/bios/mca_machdep.h>
 #endif
 
-/*
- * Per-interrupt data.
- */
-u_long	*intr_countp[ICU_LEN];		/* pointers to interrupt counters */
-driver_intr_t	*intr_handler[ICU_LEN];	/* first level interrupt handler */
-struct	 ithd *ithds[ICU_LEN];		/* real interrupt handler */
-void	*intr_unit[ICU_LEN];
-
-static struct	mtx ithds_table_lock;	/* protect the ithds table */
-
-static inthand_t *fastintr[ICU_LEN] = {
-	IDTVEC(fastintr0), IDTVEC(fastintr1),
-	IDTVEC(fastintr2), IDTVEC(fastintr3),
-	IDTVEC(fastintr4), IDTVEC(fastintr5),
-	IDTVEC(fastintr6), IDTVEC(fastintr7),
-	IDTVEC(fastintr8), IDTVEC(fastintr9),
-	IDTVEC(fastintr10), IDTVEC(fastintr11),
-	IDTVEC(fastintr12), IDTVEC(fastintr13),
-	IDTVEC(fastintr14), IDTVEC(fastintr15),
-#if defined(APIC_IO)
-	IDTVEC(fastintr16), IDTVEC(fastintr17),
-	IDTVEC(fastintr18), IDTVEC(fastintr19),
-	IDTVEC(fastintr20), IDTVEC(fastintr21),
-	IDTVEC(fastintr22), IDTVEC(fastintr23),
-	IDTVEC(fastintr24), IDTVEC(fastintr25),
-	IDTVEC(fastintr26), IDTVEC(fastintr27),
-	IDTVEC(fastintr28), IDTVEC(fastintr29),
-	IDTVEC(fastintr30), IDTVEC(fastintr31),
-#endif /* APIC_IO */
-};
-
-static unpendhand_t *fastunpend[ICU_LEN] = {
-	IDTVEC(fastunpend0), IDTVEC(fastunpend1),
-	IDTVEC(fastunpend2), IDTVEC(fastunpend3),
-	IDTVEC(fastunpend4), IDTVEC(fastunpend5),
-	IDTVEC(fastunpend6), IDTVEC(fastunpend7),
-	IDTVEC(fastunpend8), IDTVEC(fastunpend9),
-	IDTVEC(fastunpend10), IDTVEC(fastunpend11),
-	IDTVEC(fastunpend12), IDTVEC(fastunpend13),
-	IDTVEC(fastunpend14), IDTVEC(fastunpend15),
-#if defined(APIC_IO)
-	IDTVEC(fastunpend16), IDTVEC(fastunpend17),
-	IDTVEC(fastunpend18), IDTVEC(fastunpend19),
-	IDTVEC(fastunpend20), IDTVEC(fastunpend21),
-	IDTVEC(fastunpend22), IDTVEC(fastunpend23),
-	IDTVEC(fastunpend24), IDTVEC(fastunpend25),
-	IDTVEC(fastunpend26), IDTVEC(fastunpend27),
-	IDTVEC(fastunpend28), IDTVEC(fastunpend29),
-	IDTVEC(fastunpend30), IDTVEC(fastunpend31),
-#endif /* APIC_IO */
-};
-
-static inthand_t *slowintr[ICU_LEN] = {
-	IDTVEC(intr0), IDTVEC(intr1), IDTVEC(intr2), IDTVEC(intr3),
-	IDTVEC(intr4), IDTVEC(intr5), IDTVEC(intr6), IDTVEC(intr7),
-	IDTVEC(intr8), IDTVEC(intr9), IDTVEC(intr10), IDTVEC(intr11),
-	IDTVEC(intr12), IDTVEC(intr13), IDTVEC(intr14), IDTVEC(intr15),
-#if defined(APIC_IO)
-	IDTVEC(intr16), IDTVEC(intr17), IDTVEC(intr18), IDTVEC(intr19),
-	IDTVEC(intr20), IDTVEC(intr21), IDTVEC(intr22), IDTVEC(intr23),
-	IDTVEC(intr24), IDTVEC(intr25), IDTVEC(intr26), IDTVEC(intr27),
-	IDTVEC(intr28), IDTVEC(intr29), IDTVEC(intr30), IDTVEC(intr31),
-#endif /* APIC_IO */
-};
-
-static driver_intr_t isa_strayintr;
-
-static void	ithds_init(void *dummy);
-static void	ithread_enable(int vector);
-static void	ithread_disable(int vector);
-static void	init_i8259(void);
-
 #ifdef PC98
 #define NMI_PARITY 0x04
 #define NMI_EPARITY 0x02
@@ -171,80 +62,12 @@
 #define ENMI_IOSTATUS (1 << 5)
 #endif
 
-#ifdef DEV_ISA
-/*
- * Bus attachment for the ISA PIC.
- */
-static struct isa_pnp_id atpic_ids[] = {
-	{ 0x0000d041 /* PNP0000 */, "AT interrupt controller" },
-	{ 0 }
-};
-
-static int
-atpic_probe(device_t dev)
-{
-	int result;
-	
-	if ((result = ISA_PNP_PROBE(device_get_parent(dev), dev, atpic_ids)) <= 0)
-		device_quiet(dev);
-	return(result);
-}
-
-/*
- * In the APIC_IO case we might be granted IRQ 2, as this is typically
- * consumed by chaining between the two PIC components.  If we're using
- * the APIC, however, this may not be the case, and as such we should
- * free the resource.  (XXX untested)
- *
- * The generic ISA attachment code will handle allocating any other resources
- * that we don't explicitly claim here.
- */
-static int
-atpic_attach(device_t dev)
-{
-#ifdef APIC_IO
-	int		rid;
-	struct resource *res;
-
-	/* try to allocate our IRQ and then free it */
-	rid = 0;
-	res = bus_alloc_resource(dev, SYS_RES_IRQ, &rid, 0, ~0, 1, 0);
-	if (res != NULL)
-		bus_release_resource(dev, SYS_RES_IRQ, rid, res);
-#endif
-	return(0);
-}
-
-static device_method_t atpic_methods[] = {
-	/* Device interface */
-	DEVMETHOD(device_probe,		atpic_probe),
-	DEVMETHOD(device_attach,	atpic_attach),
-	DEVMETHOD(device_detach,	bus_generic_detach),
-	DEVMETHOD(device_shutdown,	bus_generic_shutdown),
-	DEVMETHOD(device_suspend,	bus_generic_suspend),
-	DEVMETHOD(device_resume,	bus_generic_resume),
-	{ 0, 0 }
-};
-
-static driver_t atpic_driver = {
-	"atpic",
-	atpic_methods,
-	1,		/* no softc */
-};
-
-static devclass_t atpic_devclass;
-
-DRIVER_MODULE(atpic, isa, atpic_driver, atpic_devclass, 0, 0);
-DRIVER_MODULE(atpic, acpi, atpic_driver, atpic_devclass, 0, 0);
-#endif /* DEV_ISA */
-
 /*
  * Handle a NMI, possibly a machine check.
  * return true to panic system, false to ignore.
  */
 int
-isa_nmi(cd)
-	int cd;
+isa_nmi(int cd)
 {
 	int retval = 0;
 #ifdef PC98
@@ -307,410 +130,3 @@
 #endif
 	return(retval);
 }
-
-/*
- *  ICU reinitialize when ICU configuration has lost.
- */
-void
-icu_reinit()
-{
-	int i;
-	register_t crit;
-
-	crit = intr_disable();
-	mtx_lock_spin(&icu_lock);
-	init_i8259();
-	for(i=0;i<ICU_LEN;i++)
-		if(intr_handler[i] != isa_strayintr)
-			INTREN(1<<i);
-	mtx_unlock_spin(&icu_lock);
-	intr_restore(crit);
-}
-
-/*
- * Create a default interrupt table to avoid problems caused by
- * spurious interrupts during configuration of kernel, then setup
- * interrupt control unit.
- */
-void
-isa_defaultirq()
-{
-	int i;
-	register_t crit;
-
-	/* icu vectors */
-	for (i = 0; i < ICU_LEN; i++)
-		icu_unset(i, (driver_intr_t *)NULL);
-	crit = intr_disable();
-	mtx_lock_spin(&icu_lock);
-	init_i8259();
-	mtx_unlock_spin(&icu_lock);
-	intr_restore(crit);
-}
-
-
-/* 
- *initialize 8259's
- */
-static void
-init_i8259()
-{
-
-#ifdef DEV_MCA
-	if (MCA_system)
-		outb(IO_ICU1, 0x19);		/* reset; program device, four bytes */
-	else
-#endif
-		outb(IO_ICU1, 0x11);		/* reset; program device, four bytes */
-
-	outb(IO_ICU1+ICU_IMR_OFFSET, NRSVIDT);	/* starting at this vector index */
-	outb(IO_ICU1+ICU_IMR_OFFSET, IRQ_SLAVE);		/* slave on line 7 */
-#ifdef PC98
-#ifdef AUTO_EOI_1
-	outb(IO_ICU1+ICU_IMR_OFFSET, 0x1f);		/* (master) auto EOI, 8086 mode */
-#else
-	outb(IO_ICU1+ICU_IMR_OFFSET, 0x1d);		/* (master) 8086 mode */
-#endif
-#else /* IBM-PC */
-#ifdef AUTO_EOI_1
-	outb(IO_ICU1+ICU_IMR_OFFSET, 2 | 1);		/* auto EOI, 8086 mode */
-#else
-	outb(IO_ICU1+ICU_IMR_OFFSET, 1);		/* 8086 mode */
-#endif
-#endif /* PC98 */
-	outb(IO_ICU1+ICU_IMR_OFFSET, 0xff);		/* leave interrupts masked */
-	outb(IO_ICU1, 0x0a);		/* default to IRR on read */
-#ifndef PC98
-	outb(IO_ICU1, 0xc0 | (3 - 1));	/* pri order 3-7, 0-2 (com2 first) */
-#endif /* !PC98 */
-
-#ifdef DEV_MCA
-	if (MCA_system)
-		outb(IO_ICU2, 0x19);		/* reset; program device, four bytes */
-	else
-#endif
-		outb(IO_ICU2, 0x11);		/* reset; program device, four bytes */
-
-	outb(IO_ICU2+ICU_IMR_OFFSET, NRSVIDT+8); /* staring at this vector index */
-	outb(IO_ICU2+ICU_IMR_OFFSET, ICU_SLAVEID);         /* my slave id is 7 */
-#ifdef PC98
-	outb(IO_ICU2+ICU_IMR_OFFSET,9);              /* 8086 mode */
-#else /* IBM-PC */
-#ifdef AUTO_EOI_2
-	outb(IO_ICU2+ICU_IMR_OFFSET, 2 | 1);		/* auto EOI, 8086 mode */
-#else
-	outb(IO_ICU2+ICU_IMR_OFFSET,1);		/* 8086 mode */
-#endif
-#endif /* PC98 */
-	outb(IO_ICU2+ICU_IMR_OFFSET, 0xff);          /* leave interrupts masked */
-	outb(IO_ICU2, 0x0a);		/* default to IRR on read */
-}
-
-/*
- * Caught a stray interrupt, notify
- */
-static void
-isa_strayintr(vcookiep)
-	void *vcookiep;
-{
-	int intr = (void **)vcookiep - &intr_unit[0];
-
-	/*
-	 * XXX TODO print a different message for #7 if it is for a
-	 * glitch.  Glitches can be distinguished from real #7's by
-	 * testing that the in-service bit is _not_ set.  The test
-	 * must be done before sending an EOI so it can't be done if
-	 * we are using AUTO_EOI_1.
-	 */
-	if (intrcnt[1 + intr] <= 5)
-		log(LOG_ERR, "stray irq %d\n", intr);
-	if (intrcnt[1 + intr] == 5)
-		log(LOG_CRIT,
-		    "too many stray irq %d's; not logging any more\n", intr);
-}
-
-#ifdef DEV_ISA
-/*
- * Return a bitmap of the current interrupt requests.  This is 8259-specific
- * and is only suitable for use at probe time.
- */
-intrmask_t
-isa_irq_pending()
-{
-	u_char irr1;
-	u_char irr2;
-
-	irr1 = inb(IO_ICU1);
-	irr2 = inb(IO_ICU2);
-	return ((irr2 << 8) | irr1);
-}
-#endif
-
-/*
- * Update intrnames array with the specified name.  This is used by
- * vmstat(8) and the like.
- */
-static void
-update_intrname(int intr, const char *name)
-{
-	char buf[32];
-	char *cp;
-	int name_index, off, strayintr;
-
-	/*
-	 * Initialise strings for bitbucket and stray interrupt counters.
-	 * These have statically allocated indices 0 and 1 through ICU_LEN.
-	 */
-	if (intrnames[0] == '\0') {
-		off = sprintf(intrnames, "???") + 1;
-		for (strayintr = 0; strayintr < ICU_LEN; strayintr++)
-			off += sprintf(intrnames + off, "stray irq%d",
-			    strayintr) + 1;
-	}
-
-	if (name == NULL)
-		name = "???";
-	if (snprintf(buf, sizeof(buf), "%s irq%d", name, intr) >= sizeof(buf))
-		goto use_bitbucket;
-
-	/*
-	 * Search for `buf' in `intrnames'.  In the usual case when it is
-	 * not found, append it to the end if there is enough space (the \0
-	 * terminator for the previous string, if any, becomes a separator).
-	 */
-	for (cp = intrnames, name_index = 0;
-	    cp != eintrnames && name_index < NR_INTRNAMES;
-	    cp += strlen(cp) + 1, name_index++) {
-		if (*cp == '\0') {
-			if (strlen(buf) >= eintrnames - cp)
-				break;
-			strcpy(cp, buf);
-			goto found;
-		}
-		if (strcmp(cp, buf) == 0)
-			goto found;
-	}
-
-use_bitbucket:
-	printf("update_intrname: counting %s irq%d as %s\n", name, intr,
-	    intrnames);
-	name_index = 0;
-found:
-	intr_countp[intr] = &intrcnt[name_index];
-}
-
-int
-icu_setup(int intr, driver_intr_t *handler, void *arg, int flags)
-{
-#ifdef FAST_HI
-	int		select;		/* the select register is 8 bits */
-	int		vector;
-	u_int32_t	value;		/* the window register is 32 bits */
-#endif /* FAST_HI */
-	register_t	crit;
-
-#if defined(APIC_IO)
-	if ((u_int)intr >= ICU_LEN)	/* no 8259 SLAVE to ignore */
-#else
-	if ((u_int)intr >= ICU_LEN || intr == ICU_SLAVEID)
-#endif /* APIC_IO */
-		return (EINVAL);
-#if 0
-	if (intr_handler[intr] != isa_strayintr)
-		return (EBUSY);
-#endif
-
-	crit = intr_disable();
-	mtx_lock_spin(&icu_lock);
-	intr_handler[intr] = handler;
-	intr_unit[intr] = arg;
-#ifdef FAST_HI
-	if (flags & INTR_FAST) {
-		vector = TPR_FAST_INTS + intr;
-		setidt(vector, fastintr[intr],
-		       SDT_SYS386IGT, SEL_KPL, GSEL(GCODE_SEL, SEL_KPL));
-	}
-	else {
-		vector = TPR_SLOW_INTS + intr;
-		setidt(vector, slowintr[intr],
-		       SDT_SYS386IGT, SEL_KPL, GSEL(GCODE_SEL, SEL_KPL));
-	}
-#ifdef APIC_INTR_REORDER
-	set_lapic_isrloc(intr, vector);
-#endif
-	/*
-	 * Reprogram the vector in the IO APIC.
-	 */
-	if (int_to_apicintpin[intr].ioapic >= 0) {
-		select = int_to_apicintpin[intr].redirindex;
-		value = io_apic_read(int_to_apicintpin[intr].ioapic, 
-				     select) & ~IOART_INTVEC;
-		io_apic_write(int_to_apicintpin[intr].ioapic, 
-			      select, value | vector);
-	}
-#else
-	setidt(ICU_OFFSET + intr,
-	       flags & INTR_FAST ? fastintr[intr] : slowintr[intr],
-	       SDT_SYS386IGT, SEL_KPL, GSEL(GCODE_SEL, SEL_KPL));
-#endif /* FAST_HI */
-	INTREN(1 << intr);
-	mtx_unlock_spin(&icu_lock);
-	intr_restore(crit);
-	return (0);
-}
-
-/*
- * Dissociate an interrupt handler from an IRQ and set the handler to
- * the stray interrupt handler.  The 'handler' parameter is used only
- * for consistency checking.
- */
-int
-icu_unset(intr, handler)
-	int	intr;
-	driver_intr_t *handler;
-{
-	register_t crit;
-
-	if ((u_int)intr >= ICU_LEN || handler != intr_handler[intr])
-		return (EINVAL);
-
-	crit = intr_disable();
-	mtx_lock_spin(&icu_lock);
-	INTRDIS(1 << intr);
-	intr_countp[intr] = &intrcnt[1 + intr];
-	intr_handler[intr] = isa_strayintr;
-	intr_unit[intr] = &intr_unit[intr];
-#ifdef FAST_HI_XXX
-	/* XXX how do I re-create dvp here? */
-	setidt(flags & INTR_FAST ? TPR_FAST_INTS + intr : TPR_SLOW_INTS + intr,
-	    slowintr[intr], SDT_SYS386IGT, SEL_KPL, GSEL(GCODE_SEL, SEL_KPL));
-#else /* FAST_HI */
-#ifdef APIC_INTR_REORDER
-	set_lapic_isrloc(intr, ICU_OFFSET + intr);
-#endif
-	setidt(ICU_OFFSET + intr, slowintr[intr], SDT_SYS386IGT, SEL_KPL,
-	    GSEL(GCODE_SEL, SEL_KPL));
-#endif /* FAST_HI */
-	mtx_unlock_spin(&icu_lock);
-	intr_restore(crit);
-	return (0);
-}
-
-static void
-ithds_init(void *dummy)
-{
-
-	mtx_init(&ithds_table_lock, "ithread table lock", NULL, MTX_SPIN);
-}
-SYSINIT(ithds_init, SI_SUB_INTR, SI_ORDER_SECOND, ithds_init, NULL);
-
-static void
-ithread_enable(int vector)
-{
-	register_t crit;
-
-	crit = intr_disable();
-	mtx_lock_spin(&icu_lock);
-	INTREN(1 << vector);
-	mtx_unlock_spin(&icu_lock);
-	intr_restore(crit);
-}
-
-static void
-ithread_disable(int vector)
-{
-	register_t crit;
-
-	crit = intr_disable();
-	mtx_lock_spin(&icu_lock);
-	INTRDIS(1 << vector);
-	mtx_unlock_spin(&icu_lock);
-	intr_restore(crit);
-}
-
-int
-inthand_add(const char *name, int irq, driver_intr_t handler, void *arg,
-    enum intr_type flags, void **cookiep)
-{
-	struct ithd *ithd;		/* descriptor for the IRQ */
-	int errcode = 0;
-	int created_ithd = 0;
-
-	/*
-	 * Work around a race where more than one CPU may be registering
-	 * handlers on the same IRQ at the same time.
-	 */
-	mtx_lock_spin(&ithds_table_lock);
-	ithd = ithds[irq];
-	mtx_unlock_spin(&ithds_table_lock);
-	if (ithd == NULL) {
-		errcode = ithread_create(&ithd, irq, 0, ithread_disable,
-		    ithread_enable, "irq%d:", irq);
-		if (errcode)
-			return (errcode);
-		mtx_lock_spin(&ithds_table_lock);
-		if (ithds[irq] == NULL) {
-			ithds[irq] = ithd;
-			created_ithd++;
-			mtx_unlock_spin(&ithds_table_lock);
-		} else {
-			struct ithd *orphan;
-
-			orphan = ithd;
-			ithd = ithds[irq];
-			mtx_unlock_spin(&ithds_table_lock);
-			ithread_destroy(orphan);
-		}
-	}
-
-	errcode = ithread_add_handler(ithd, name, handler, arg,
-	    ithread_priority(flags), flags, cookiep);
-	
-	if ((flags & INTR_FAST) == 0 || errcode)
-		/*
-		 * The interrupt process must be in place, but
-		 * not necessarily schedulable, before we
-		 * initialize the ICU, since it may cause an
-		 * immediate interrupt.
-		 */
-		if (icu_setup(irq, sched_ithd, arg, flags) != 0)
-			panic("inthand_add: Can't initialize ICU");
-
-	if (errcode)
-		return (errcode);
-	
-	if (flags & INTR_FAST) {
-		errcode = icu_setup(irq, handler, arg, flags);
-		if (errcode && bootverbose)
-			printf("\tinthand_add(irq%d) failed, result=%d\n", 
-			       irq, errcode);
-		if (errcode)
-			return (errcode);
-	}
-
-	update_intrname(irq, name);
-	return (0);
-}
-
-/*
- * Deactivate and remove linked list the interrupt handler descriptor
- * data connected created by an earlier call of inthand_add(), then
- * adjust the interrupt masks if necessary.
- *
- * Return the memory held by the interrupt handler descriptor data
- * structure to the system.  First ensure the handler is not actively
- * in use.
- */
-int
-inthand_remove(void *cookie)
-{
-
-	return (ithread_remove_handler(cookie));
-}
-
-void
-call_fast_unpend(int irq)
-{
- 	fastunpend[irq]();
-}
-
Index: i386/isa/npx.c
===========================================================================
--- sys/i386/isa/npx.c	2003/10/30 14:48:07	#38
+++ i386/isa/npx.c	2003/10/30 14:48:07
@@ -52,6 +52,7 @@
 #include <sys/mutex.h>
 #include <sys/mutex.h>
 #include <sys/proc.h>
+#include <sys/smp.h>
 #include <sys/sysctl.h>
 #include <machine/bus.h>
 #include <sys/rman.h>
@@ -61,31 +62,25 @@
 #include <sys/signalvar.h>
 #include <sys/user.h>
 
-#ifndef SMP
 #include <machine/asmacros.h>
-#endif
 #include <machine/cputypes.h>
 #include <machine/frame.h>
 #include <machine/md_var.h>
 #include <machine/pcb.h>
 #include <machine/psl.h>
-#ifndef SMP
 #include <machine/clock.h>
-#endif
 #include <machine/resource.h>
 #include <machine/specialreg.h>
 #include <machine/segments.h>
 #include <machine/ucontext.h>
 
-#ifndef SMP
 #include <i386/isa/icu.h>
 #ifdef PC98
 #include <pc98/pc98/pc98.h>
 #else
 #include <i386/isa/isa.h>
 #endif
-#endif
-#include <i386/isa/intr_machdep.h>
+#include <machine/intr_machdep.h>
 #ifdef DEV_ISA
 #include <isa/isavar.h>
 #endif
@@ -165,9 +160,7 @@
 static	void	fpurstor(union savefpu *);
 static	int	npx_attach(device_t dev);
 static	void	npx_identify(driver_t *driver, device_t parent);
-#ifndef SMP
 static	void	npx_intr(void *);
-#endif
 static	int	npx_probe(device_t dev);
 #ifdef I586_CPU_XXX
 static	long	timezero(const char *funcname,
@@ -180,10 +173,8 @@
 	CTLFLAG_RD, &hw_float, 0, 
 	"Floatingpoint instructions executed in hardware");
 
-#ifndef SMP
 static	volatile u_int		npx_intrs_while_probing;
 static	volatile u_int		npx_traps_while_probing;
-#endif
 
 static	union savefpu		npx_cleanstate;
 static	bool_t			npx_cleanstate_ready;
@@ -191,7 +182,6 @@
 static	bool_t			npx_exists;
 static	bool_t			npx_irq13;
 
-#ifndef SMP
 alias_for_inthand_t probetrap;
 __asm("								\n\
 	.text							\n\
@@ -203,7 +193,6 @@
 	fnclex							\n\
 	iret							\n\
 ");
-#endif /* SMP */
 
 /*
  * Identify routine.  Create a connection point on our parent for probing.
@@ -220,7 +209,6 @@
 		panic("npx_identify");
 }
 
-#ifndef SMP
 /*
  * Do minimal handling of npx interrupts to convert them to traps.
  */
@@ -230,9 +218,7 @@
 {
 	struct thread *td;
 
-#ifndef SMP
 	npx_intrs_while_probing++;
-#endif
 
 	/*
 	 * The BUSY# latch must be cleared in all cases so that the next
@@ -264,7 +250,6 @@
 		mtx_unlock_spin(&sched_lock);
 	}
 }
-#endif /* !SMP */
 
 /*
  * Probe routine.  Initialize cr0 to give correct behaviour for [f]wait
@@ -276,7 +261,6 @@
 npx_probe(dev)
 	device_t dev;
 {
-#ifndef SMP
 	struct gate_descriptor save_idt_npxtrap;
 	struct resource *ioport_res, *irq_res;
 	void *irq_cookie;
@@ -307,7 +291,6 @@
 	if (bus_setup_intr(dev, irq_res, INTR_TYPE_MISC | INTR_FAST, npx_intr,
 	    NULL, &irq_cookie) != 0)
 		panic("npx: can't create intr");
-#endif /* !SMP */
 
 	/*
 	 * Partially reset the coprocessor, if any.  Some BIOS's don't reset
@@ -348,16 +331,6 @@
 
 	device_set_desc(dev, "math processor");
 
-#ifdef SMP
-
-	/*
-	 * Exception 16 MUST work for SMP.
-	 */
-	npx_ex16 = hw_float = npx_exists = 1;
-	return (0);
-
-#else /* !SMP */
-
 	/*
 	 * Don't use fwait here because it might hang.
 	 * Don't use fnop here because it usually hangs if there is no FPU.
@@ -413,6 +386,10 @@
 				 */
 				npx_irq13 = 1;
 				idt[IDT_MF] = save_idt_npxtrap;
+#ifdef SMP
+				if (mp_ncpus > 1)
+					panic("npx0 cannot use IRQ 13 on an SMP system");
+#endif
 				return (0);
 			}
 			/*
@@ -425,6 +402,10 @@
 	 * emulator and say that it has been installed.  XXX handle devices
 	 * that aren't really devices better.
 	 */
+#ifdef SMP
+	if (mp_ncpus > 1)
+		panic("npx0 cannot be emulated on an SMP system");
+#endif
 	/* FALLTHROUGH */
 no_irq13:
 	idt[IDT_MF] = save_idt_npxtrap;
@@ -435,20 +416,15 @@
 	 * irq active then we would get it instead of exception 16.
 	 */
 	{
-		register_t crit;
+		struct intsrc *isrc;
 
-		crit = intr_disable();
-		mtx_lock_spin(&icu_lock);
-		INTRDIS(1 << irq_num);
-		mtx_unlock_spin(&icu_lock);
-		intr_restore(crit);
+		isrc = intr_lookup_source(irq_num);
+		isrc->is_pic->pic_disable_source(isrc);
 	}
 
 	bus_release_resource(dev, SYS_RES_IRQ, irq_rid, irq_res);
 	bus_release_resource(dev, SYS_RES_IOPORT, ioport_rid, ioport_res);
 	return (0);
-
-#endif /* SMP */
 }
 
 /*
Index: i386/pci/pci_bus.c
===========================================================================
--- sys/i386/pci/pci_bus.c	2003/10/30 14:48:07	#31
+++ i386/pci/pci_bus.c	2003/10/30 14:48:07
@@ -420,7 +420,7 @@
 
 	if (pci_cfgregopen() == 0)
 		return ENXIO;
-	return 0;
+	return -100;
 }
 
 int
Index: i386/pci/pci_cfgreg.c
===========================================================================
--- sys/i386/pci/pci_cfgreg.c	2003/10/30 14:48:07	#31
+++ i386/pci/pci_cfgreg.c	2003/10/30 14:48:07
@@ -48,10 +48,6 @@
 #include <machine/segments.h>
 #include <machine/pc/bios.h>
 
-#ifdef APIC_IO
-#include <machine/smp.h>
-#endif /* APIC_IO */
-
 #include "pcib_if.h"
 
 #define PRVERB(a) do {							\
@@ -201,60 +197,17 @@
 pci_cfgregread(int bus, int slot, int func, int reg, int bytes)
 {
 	uint32_t line;
-#ifdef APIC_IO
-	uint32_t pin;
 
 	/*
-	 * If we are using the APIC, the contents of the intline
-	 * register will probably be wrong (since they are set up for
-	 * use with the PIC.  Rather than rewrite these registers
-	 * (maybe that would be smarter) we trap attempts to read them
-	 * and translate to our private vector numbers.
-	 */
-	if ((reg == PCIR_INTLINE) && (bytes == 1)) {
-
-		pin = pcireg_cfgread(bus, slot, func, PCIR_INTPIN, 1);
-		line = pcireg_cfgread(bus, slot, func, PCIR_INTLINE, 1);
-
-		if (pin != 0) {
-			int airq;
-
-			airq = pci_apic_irq(bus, slot, pin);
-			if (airq >= 0) {
-				/* PCI specific entry found in MP table */
-				if (airq != line)
-					undirect_pci_irq(line);
-				return(airq);
-			} else {
-				/* 
-				 * PCI interrupts might be redirected
-				 * to the ISA bus according to some MP
-				 * tables. Use the same methods as
-				 * used by the ISA devices devices to
-				 * find the proper IOAPIC int pin.
-				 */
-				airq = isa_apic_irq(line);
-				if ((airq >= 0) && (airq != line)) {
-					/* XXX: undirect_pci_irq() ? */
-					undirect_isa_irq(line);
-					return(airq);
-				}
-			}
-		}
-		return(line);
-	}
-#else
-	/*
 	 * Some BIOS writers seem to want to ignore the spec and put
 	 * 0 in the intline rather than 255 to indicate none.  The rest of
 	 * the code uses 255 as an invalid IRQ.
 	 */
 	if (reg == PCIR_INTLINE && bytes == 1) {
 		line = pcireg_cfgread(bus, slot, func, PCIR_INTLINE, 1);
-		return pci_i386_map_intline(line);
+		return (pci_i386_map_intline(line));
 	}
-#endif /* APIC_IO */
-	return(pcireg_cfgread(bus, slot, func, reg, bytes));
+	return (pcireg_cfgread(bus, slot, func, reg, bytes));
 }
 
 /* 
Index: kern/kern_intr.c
===========================================================================
--- sys/kern/kern_intr.c	2003/10/30 14:48:07	#39
+++ kern/kern_intr.c	2003/10/30 14:48:07
@@ -250,8 +250,6 @@
 
 	if (ithread == NULL || name == NULL || handler == NULL)
 		return (EINVAL);
-	if ((flags & INTR_FAST) !=0)
-		flags |= INTR_EXCL;
 
 	ih = malloc(sizeof(struct intrhand), M_ITHREAD, M_WAITOK | M_ZERO);
 	ih->ih_handler = handler;
@@ -260,7 +258,7 @@
 	ih->ih_ithread = ithread;
 	ih->ih_pri = pri;
 	if (flags & INTR_FAST)
-		ih->ih_flags = IH_FAST | IH_EXCLUSIVE;
+		ih->ih_flags = IH_FAST;
 	else if (flags & INTR_EXCL)
 		ih->ih_flags = IH_EXCLUSIVE;
 	if (flags & INTR_MPSAFE)
@@ -269,11 +267,17 @@
 		ih->ih_flags |= IH_ENTROPY;
 
 	mtx_lock(&ithread->it_lock);
-	if ((flags & INTR_EXCL) !=0 && !TAILQ_EMPTY(&ithread->it_handlers))
+	if ((flags & INTR_EXCL) != 0 && !TAILQ_EMPTY(&ithread->it_handlers))
 		goto fail;
-	if (!TAILQ_EMPTY(&ithread->it_handlers) &&
-	    (TAILQ_FIRST(&ithread->it_handlers)->ih_flags & IH_EXCLUSIVE) != 0)
-		goto fail;
+	if (!TAILQ_EMPTY(&ithread->it_handlers)) {
+		temp_ih = TAILQ_FIRST(&ithread->it_handlers);
+		if (temp_ih->ih_flags & IH_EXCLUSIVE)
+			goto fail;
+		if ((ih->ih_flags & IH_FAST) && !(temp_ih->ih_flags & IH_FAST))
+			goto fail;
+		if (!(ih->ih_flags & IH_FAST) && (temp_ih->ih_flags & IH_FAST))
+			goto fail;
+	}
 
 	TAILQ_FOREACH(temp_ih, &ithread->it_handlers, ih_next)
 	    if (temp_ih->ih_pri > ih->ih_pri)
Index: kern/subr_witness.c
===========================================================================
--- sys/kern/subr_witness.c	2003/10/30 14:48:07	#81
+++ kern/subr_witness.c	2003/10/30 14:48:07
@@ -285,6 +285,7 @@
 	{ "ng_node", &lock_class_mtx_spin },
 	{ "ng_worklist", &lock_class_mtx_spin },
 	{ "taskqueue_fast", &lock_class_mtx_spin },
+	{ "intr table", &lock_class_mtx_spin },
 	{ "ithread table lock", &lock_class_mtx_spin },
 	{ "sched lock", &lock_class_mtx_spin },
 	{ "callout", &lock_class_mtx_spin },
@@ -296,10 +297,8 @@
 	{ "icu", &lock_class_mtx_spin },
 #ifdef SMP
 	{ "smp rendezvous", &lock_class_mtx_spin },
-#if defined(__i386__) && defined(APIC_IO)
+#ifdef __i386__
 	{ "tlb", &lock_class_mtx_spin },
-#endif
-#ifdef __i386__
 	{ "lazypmap", &lock_class_mtx_spin },
 #endif
 #ifdef __sparc64__
Index: modules/acpi/Makefile
===========================================================================
--- sys/modules/acpi/Makefile	2003/10/30 14:48:07	#21
+++ modules/acpi/Makefile	2003/10/30 14:48:07
@@ -66,6 +66,9 @@
 
 # Machine-specific code such as sleep/wakeup
 SRCS+=	acpi_machdep.c acpi_wakecode.h acpi_wakeup.c
+.if ${MACHINE} == "i386"
+SRCS+=	madt.c
+.endif
 CLEANFILES+=	acpi_wakecode.h acpi_wakecode.o acpi_wakecode.bin
 
 acpi_wakecode.h: acpi_wakecode.S
Index: notes
===========================================================================
*** /dev/null	Thu Oct 30 14:47:44 2003
--- notes	Thu Oct 30 14:48:10 2003
***************
*** 0 ****
--- 1,99 ----
+ All files are under sys/i386
+ 
+ Files moved in this branch:
+ - include/apic.h -> include/apicreg.h
+ - isa/apic_vector.s -> i386/apic_vector.s
+ - isa/icu_vector.s -> isa/atpic_vector.s
+ - isa/intr_machdep.c -> isa/atpic.c (sort of)
+ - isa/intr_machdep.c -> isa/nmi.c
+ - isa/intr_machdep.h -> include/intr_machdep.h (sort of)
+ 
+ New files:
+ - i386/local_apic.c
+ - i386/io_apic.c
+ - i386/mptable.c  (from mp_machdep.c)
+ - i386/mptable_pci.c
+ - include/apicvar.h
+ - include/mptable.h (from mp_machdep.c)
+ 
+ Files removed in this branch:
+ - conf/SMP
+ - i386/mpapic.c
+ - isa/intr_machdep.c
+ - isa/intr_machdep.h
+ - isa/icu_ipl.s
+ - isa/icu_vector.s
+ - isa/apic_ipl.s
+ - isa/apic_vector.s
+ - isa/ithread.c
+ - isa/vector.s
+ 
+ Todo:
+ - DDB
+   + Add APIC ID to show pcpu
+   + Add 'show intrcnt'
+   + Add 'show idt'
+   - Add 'show ithread'
+   + Add 'show irqs'
+     - print out PIC driver name for each IRQ?
+   - Add 'show irq'
+ + Add nmi.c
+ + Set PCPU(apic_id) for UP case in lapic_init().
+ + Use apic id of BSP (current CPU) when programming temporary physical
+   destinations into I/O APIC RDT entries.
+ + Fix IDT_SYSCALL mapping in APIC case
+   + Retest interrupts
+   - Somehow test IRQ's in this range?
+ + Test mixed mode
+   + works on SMP when single physical destination
+ + Fix bogus SMP probe when only 1 CPU
+ - Kill isa_irq_pending()  (maybe, is this an MI function?)
+ + Add ACPI MADT APIC enumerator.
+   + solve ACPI module problem where madt wants APIC symbols :(
+     (this is gross)
+   - doesn't work when loaded as a module
+     - UMA needs to be fixed to not need mp_maxid so early
+       - other workaround is to fix mp_maxid at MAXCPU
+     - move cpu_mp_probe() to SI_SUB_CPU  (perhaps shuffle SI of other
+       SMP sysinits as a result)
+     - update apic enumerators to probe CPUs later
+     - have apic enumerators hookup to the apic subsystem after SI_SUB_KLD
+       maybe SI_ORDER_LAST
+   - disable ACPI module for now
+ - Need to fix kernel profiling madness.  Add an 'etrap' and perhaps
+   support for bintr2() and eintr2().
+ + Implement mixed-mode and use it for IRQ0 unless no ExtINT pin or
+   NO_MIXED_MODE
+   + Add NO_MIXED_MODE option
+   - Add runtime decision for IRQ0 mixed mode?
+ + SMP bogons
+   + doesn't work on 750x
+   + pmap_lazyfix unhappy with old-style critical sections
+ - Chokes on scott's dual P3 when looking for ACPI RSDT.
+ - Perhaps change the IRQ resource manager such that it starts out empty
+   and a resource entry for each IRQ is added as each IRQ is registered
+ - Clean up includes in new files.
+ - Check #ifdef's in new files and look for #if 0 in new code
+ - Add handling of local APIC ERROR lvt.
+ - Use the local apic timer to drive hard/stat/profclock (maybe too hard)
+ - Do we need to be able to renumber I/O APICs?
+   - Check for overlap in table-specified APICs
+   - Ignore I/O APIC ID's if we have a local xAPIC (john cagle, Intel PDF)
+   - Renumber I/O APIC IDs.  Ugh.  Not sure if this will have to be done for
+     the general case or just for the mptable case.  Update: may not have to,
+     it was a BIOS bug.  May have to bump NAPICID to 256 though.
+ - Flesh out cpu topology map
+ - Suspend/resume support for I/O APICs
+ - check XXX and XXXTEST in new code
+ - reimplement lazy masking of interrupts for critical sections w/o bitmasks??
+ - Enhance acpi_cpu(4) driver to grok SMP at all?
+ - Rip out CPU halting stuff perhaps and maybe disable MPTable HTT fixup?
+ - Support bus_config_intr()?
+   - nexus would have to call intr_config_source()
+   - intr_config_source() would call config_source() method of PIC driver
+   - AT PIC driver could just ignore
+   - APIC driver could reprogram I/O redirection entry
+ 
+ Unrelated to this branch:
+ - Work on cleaning up nested includes in sys/* headers.  According to Bruce,
+   the only nested sys/* headers should be _*.h and queue.h.
Index: pc98/conf/GENERIC
===========================================================================
--- sys/pc98/conf/GENERIC	2003/10/30 14:48:07	#58
+++ pc98/conf/GENERIC	2003/10/30 14:48:07
@@ -72,7 +72,7 @@
 
 device		isa
 device		pci
-#options 	COMPAT_OLDISA		# Old ISA driver shims
+options 	COMPAT_OLDISA		# Old ISA driver shims
 
 # Floppy drives
 device		fdc
@@ -101,7 +101,7 @@
 
 device		aic		# PC-9801-100
 #options 	BS_TARG_SAFEMODE
-#device		bs	1	# WD33C93 SCSI card (55/92 like board)
+device		bs	1	# WD33C93 SCSI card (55/92 like board)
 device		ct		# host adapter using WD33C93[ABC] chip (C bus)
 
 device		ncv		# NCR 53C500
Index: setup.sh
===========================================================================
*** /dev/null	Thu Oct 30 14:47:44 2003
--- setup.sh	Thu Oct 30 14:48:10 2003
***************
*** 0 ****
--- 1,27 ----
+ #!/bin/sh
+ #
+ # A simple script to create necessary symlinks for a kernel to build in this
+ # branch.
+ 
+ # link oldname newname
+ #
+ # Where oldname is relative to the directory containing newname
+ link()
+ {
+ 	dir=`dirname $2`
+ 	old=$1
+ 	new=`basename $2`
+ 
+ 	(cd $dir ; ln -s $old $new )
+ }
+ 
+ # Make sure we are in the right place
+ if ! [ -r setup.sh ]; then
+ 	echo "This must be run from the top-level kernel source directory."
+ 	exit 1
+ fi
+ 
+ link apic.h i386/include/apicreg.h
+ link ../isa/apic_vector.s i386/i386/apic_vector.s
+ link icu_vector.s i386/isa/atpic_vector.s
+ link intr_machdep.c i386/isa/nmi.c
